<template>
  <div>
    <div>

      <div class="jumbotron" v-if="oldQueen.toString().length > 3">
        <h2>Edytuj królową</h2>
      </div>

      <form
          v-on:submit.prevent="submitForm"
      >

        <div class="form-group">

          <label for="dateOfApplication">Data wstawienia do ula:</label>
          <vue-englishdatepicker id="dateOfApplication" v-model="form.dateOfApplication"/>
          <br/>
          Aktualna data wstawienia do ula: <strong>{{ oldQueen.dateOfApplication }}</strong>
        </div>

        <hr>

        <div class="form-group">
          <label for="queenNo">Nowy nr królowej:</label>
          <input type="text"
                 class="form-control"
                 id="queenNo"
                 @keypress="onlyNumber"
                 placeholder="Nowy numer"
                 @input="e => form.queenNo = e.target.value"
          >
        </div>

        <div class="form-group">
          <label for="colour">Nowy kolor królowej:</label>
          <input type="text"
                 class="form-control"
                 id="colour"
                 placeholder="Nowy kolor"
                 @input="e => form.colour = e.target.value"
          >
        </div>

        <div class="form-group">
          <label for="variety">Nowa rasa królowej:</label>
          <input type="text"
                 class="form-control"
                 id="variety"
                 placeholder="Nowa rasa"
                 maxlength="20"
                 @input="e => form.variety = e.target.value"
          >
        </div>

        <div class="form-group">
          <label for="fertile">Płodna?</label>
          <input type="checkbox"
                 id="fertile"
                 :checked="oldQueen.fertile === true"
                 v-on:input="form.fertile = $event.target.checked; flagFertile = true"
          >
        </div>

        <div class="form-group">
          <button class="btn btn-primary">Edytuj</button>
        </div>
      </form>
    </div>
  </div>
</template>

<script>
import QueenService from '../../services/queen.service';
import VueEnglishdatepicker from 'vue-englishdatepicker';

import 'vue-slider-component/theme/antd.css'
import queenobject from "@/models/queenobject";

export default {
  name: 'EditQueen',
  components: {
    VueEnglishdatepicker,
  },
  data() {
    return {
      content: '',
      form: new queenobject('', '', false, '', '', ''),
      oldQueen: '',
      flagFertile: false
    };
  },
  computed: {
    currentUser() {
      return this.$store.state.auth.user;
    }
  },
  mounted() {

    if (!this.currentUser) {
      this.$router.push('/login');
    } else if (this.$route.query.beehiveId && this.$route.query.queenId) {
      QueenService.getSpecificQueenById(this.$route.query.queenId).then(
          response => {
            this.oldQueen = response.data;
            document.getElementById("queenNo").value = this.oldQueen.queenNo;
            document.getElementById("colour").value = this.oldQueen.colour;
            document.getElementById("variety").value = this.oldQueen.variety;
          },
          error => {
            this.oldQueen =
                (error.response && error.response.data && error.response.data.message) ||
                error.message ||
                error.toString();
          }
      );
    }

  },
  methods: {
    submitForm() {

      if (!this.currentUser) {
        this.$router.push('/login');
      } else {

        if (!this.currentUser) {
          this.$router.push('/login');
        } else if (this.$route.query.beehiveId && this.$route.query.queenId) {

          this.putOldData()

          this.form.beehiveId = this.$route.query.beehiveId

          QueenService.editQueen(this.form, this.$route.query.queenId).then(
              response => {
                this.content = response.data;

                alert('Królowa edytowana poprawnie!')

                this.$router.push('/beehive?beehiveid=' + this.$route.query.beehiveId)

              },
              error => {
                this.content =
                    (error.response && error.response.data && error.response.data.message) ||
                    error.message ||
                    error.toString();
              }
          );
        }
      }
    },

    putOldData() {
      if (!this.form.dateOfApplication)
        this.form.dateOfApplication = this.oldQueen.dateOfApplication;

      if (!this.form.queenNo)
        this.form.queenNo = this.oldQueen.queenNo;

      if (!this.form.colour)
        this.form.colour = this.oldQueen.colour;

      if (!this.form.variety)
        this.form.variety = this.oldQueen.variety;

      if (!this.flagFertile)
        this.form.fertile = this.oldQueen.fertile;

    },

    onlyNumber($event) {
      //console.log($event.keyCode); //keyCodes value
      let keyCode = ($event.keyCode ? $event.keyCode : $event.which);
      if ((keyCode < 48 || keyCode > 57) && keyCode !== 46) { // 46 is dot
        $event.preventDefault();
      }
    }
  }
};
</script>

<style scoped>
label {
  display: block;
  margin-top: 10px;
}
</style>